# Generated by Django 4.1.13 on 2025-01-03 15:08

from django.db import migrations, models
import django.db.models.deletion
import model
import utils.util


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='PolicyFile',
            fields=[
                ('id', model.FixCharField(default=utils.util.get_uuid, max_length=32, primary_key=True, serialize=False)),
                ('create_time', model.DateTimeFormatField(auto_now_add=True)),
                ('update_time', model.DateTimeFormatField(auto_now=True)),
                ('name', models.CharField(blank=True, max_length=64, null=True, verbose_name='策略名称')),
                ('protoData', models.BinaryField(blank=True, null=True, verbose_name='配置数据')),
                ('remark', models.CharField(blank=True, max_length=512, null=True, verbose_name='备注')),
            ],
            options={
                'verbose_name': '策略文件表',
                'verbose_name_plural': '策略文件表',
                'db_table': 'asset_policy_file',
            },
        ),
        migrations.CreateModel(
            name='Tag',
            fields=[
                ('id', model.FixCharField(default=utils.util.get_uuid, max_length=32, primary_key=True, serialize=False)),
                ('create_time', model.DateTimeFormatField(auto_now_add=True)),
                ('update_time', model.DateTimeFormatField(auto_now=True)),
                ('name', models.CharField(blank=True, max_length=64, null=True, verbose_name='标签名称')),
            ],
            options={
                'verbose_name': '标签表',
                'verbose_name_plural': '标签表',
                'db_table': 'asset_tag',
            },
        ),
        migrations.CreateModel(
            name='Group',
            fields=[
                ('id', model.FixCharField(default=utils.util.get_uuid, max_length=32, primary_key=True, serialize=False)),
                ('create_time', model.DateTimeFormatField(auto_now_add=True)),
                ('update_time', model.DateTimeFormatField(auto_now=True)),
                ('name', models.CharField(blank=True, max_length=64, null=True, verbose_name='分组名称')),
                ('push_time', model.DateTimeFormatField(blank=True, null=True, verbose_name='策略下发时间')),
                ('policyfile', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='groups', to='asset.policyfile', verbose_name='关联策略文件')),
            ],
            options={
                'verbose_name': '分组表',
                'verbose_name_plural': '分组表',
                'db_table': 'asset_group',
            },
        ),
        migrations.CreateModel(
            name='BusinessConfig',
            fields=[
                ('create_time', model.DateTimeFormatField(auto_now_add=True)),
                ('update_time', model.DateTimeFormatField(auto_now=True)),
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('dataType', models.IntegerField(blank=True, null=True, verbose_name='数据类型')),
                ('protoData', models.BinaryField(blank=True, null=True, verbose_name='配置数据')),
                ('processState', models.SmallIntegerField(default=0, verbose_name='处理状态，0：未下发，1：已下发，2：处理失败')),
                ('processErrorInfo', models.TextField(blank=True, null=True, verbose_name='错误信息')),
                ('group', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='businessconfigs', to='asset.group', verbose_name='关联分组')),
            ],
            options={
                'verbose_name': '下发策略表',
                'verbose_name_plural': '下发策略表',
                'db_table': 'asset_business_config',
            },
        ),
        migrations.CreateModel(
            name='Business',
            fields=[
                ('id', model.FixCharField(default=utils.util.get_uuid, max_length=32, primary_key=True, serialize=False)),
                ('create_time', model.DateTimeFormatField(auto_now_add=True)),
                ('update_time', model.DateTimeFormatField(auto_now=True)),
                ('page', models.CharField(blank=True, max_length=64, null=True, verbose_name='页面关联')),
                ('data', models.TextField(blank=True, null=True, verbose_name='数据')),
                ('group', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='businesss', to='asset.group', verbose_name='关联分组')),
            ],
            options={
                'verbose_name': '策略配置表',
                'verbose_name_plural': '策略配置表',
                'db_table': 'asset_business',
            },
        ),
        migrations.CreateModel(
            name='AuthRecord',
            fields=[
                ('id', model.FixCharField(default=utils.util.get_uuid, max_length=32, primary_key=True, serialize=False)),
                ('create_time', model.DateTimeFormatField(auto_now_add=True)),
                ('update_time', model.DateTimeFormatField(auto_now=True)),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, unique=True, verbose_name='单机设备mac地址')),
                ('localIpAddr', models.CharField(blank=True, max_length=128, null=True, verbose_name='局域网IP地址')),
                ('netIpAddr', models.CharField(blank=True, max_length=128, null=True, verbose_name='接收到的实际网络IP地址')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('systemVersion', models.CharField(blank=True, max_length=255, null=True, verbose_name='系统版本')),
                ('onlineState', models.SmallIntegerField(blank=True, null=True, verbose_name='在线状态，0：离线，1：在线')),
                ('authState', models.SmallIntegerField(blank=True, null=True, verbose_name='授权与否，0：未授权，1：授权')),
                ('group', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='authrecords', to='asset.group', verbose_name='关联分组')),
                ('tags', models.ManyToManyField(blank=True, db_constraint=False, null=True, related_name='authrecords', to='asset.tag', verbose_name='关联用户')),
            ],
            options={
                'verbose_name': '授权记录表',
                'verbose_name_plural': '授权记录表',
                'db_table': 'asset_auth_record',
            },
        ),
    ]
