# Generated by Django 4.1.13 on 2025-01-03 15:08

from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='SecureLogRecord',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('time', models.IntegerField(blank=True, null=True, verbose_name='日志生成时间，时间戳(s)')),
                ('auditType', models.IntegerField(blank=True, null=True, verbose_name='日志类型,10完整性度量,20访问控制,30系统保护,40加固选项')),
                ('userName', models.CharField(blank=True, max_length=255, null=True, verbose_name='用户名称')),
                ('processResult', models.IntegerField(blank=True, null=True, verbose_name='操作结果，0：失败，1：成功')),
                ('processType', models.IntegerField(blank=True, null=True, verbose_name='是否处理，暂时不用')),
                ('summary', models.CharField(blank=True, max_length=500, null=True, verbose_name='操作概要')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
                ('auditSubType', models.IntegerField(blank=True, null=True, verbose_name='日志子类型')),
            ],
            options={
                'verbose_name': '安全日志表',
                'verbose_name_plural': '安全日志表',
                'db_table': 'secureLog_record',
            },
        ),
        migrations.CreateModel(
            name='SystemLogAlertLevelInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('action', models.CharField(blank=True, max_length=500, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '警戒级别表',
                'verbose_name_plural': '警戒级别表',
                'db_table': 'systemLog_alertLevelInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogAppInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志入本地表时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('source', models.CharField(blank=True, max_length=45, null=True, verbose_name='来源')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='信息')),
            ],
            options={
                'verbose_name': '应用日志表',
                'verbose_name_plural': '应用日志表',
                'db_table': 'systemLog_appInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogAuditInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='描述')),
            ],
            options={
                'verbose_name': '审计信息表',
                'verbose_name_plural': '审计信息表',
                'db_table': 'systemLog_auditInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogCritLevelInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志入本地表时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('action', models.CharField(blank=True, max_length=500, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '临界级别表',
                'verbose_name_plural': '临界级别表',
                'db_table': 'systemLog_critLevelInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogDebugLevelInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志入本地表时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('action', models.CharField(blank=True, max_length=500, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '调试级别表',
                'verbose_name_plural': '调试级别表',
                'db_table': 'systemLog_debugLevelInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogEmergLevelInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志入本地表时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('action', models.CharField(blank=True, max_length=500, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '致命级别表',
                'verbose_name_plural': '致命级别表',
                'db_table': 'systemLog_emergLevelInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogErrLevelInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志入本地表时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('action', models.CharField(blank=True, max_length=500, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '错误级别表',
                'verbose_name_plural': '错误级别表',
                'db_table': 'systemLog_errLevelInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogInfoLevelInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志入本地表时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('action', models.CharField(blank=True, max_length=500, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '通知级别表',
                'verbose_name_plural': '通知级别表',
                'db_table': 'systemLog_infoLevelInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogKernelInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志入本地表时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '内核信息表',
                'verbose_name_plural': '内核信息表',
                'db_table': 'systemLog_kernelInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogNoticeLevelInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志入本地表时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('action', models.CharField(blank=True, max_length=500, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '注意级别表',
                'verbose_name_plural': '注意级别表',
                'db_table': 'systemLog_noticeLevelInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogPacketInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志入本地表时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('state', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('desc', models.CharField(blank=True, max_length=255, null=True, verbose_name='软件包名')),
            ],
            options={
                'verbose_name': '包安装情况表',
                'verbose_name_plural': '包安装情况表',
                'db_table': 'systemLog_packetInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogPrintInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志入本地表时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('userName', models.CharField(blank=True, max_length=255, null=True, verbose_name='用户名')),
                ('action', models.CharField(blank=True, max_length=255, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=255, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '打印信息表',
                'verbose_name_plural': '打印信息表',
                'db_table': 'systemLog_printInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogRecordInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '刻录信息表',
                'verbose_name_plural': '刻录信息表',
                'db_table': 'systemLog_recordInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogSessionInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '会话日志表',
                'verbose_name_plural': '会话日志表',
                'db_table': 'systemLog_sessionInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogSoftUpdateInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '软件更新情况表',
                'verbose_name_plural': '软件更新情况表',
                'db_table': 'systemLog_softUpdateInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogStartInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('action', models.CharField(blank=True, max_length=500, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '系统启动情况表',
                'verbose_name_plural': '系统启动情况表',
                'db_table': 'systemLog_startInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogSwitchCount',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('year', models.CharField(blank=True, max_length=45, null=True, verbose_name='年份')),
                ('month', models.CharField(blank=True, max_length=45, null=True, verbose_name='月份')),
                ('loginCount', models.CharField(blank=True, max_length=45, null=True, verbose_name='登录次数')),
                ('switchCount', models.CharField(blank=True, max_length=45, null=True, verbose_name='开机次数')),
                ('shutdownCount', models.CharField(blank=True, max_length=45, null=True, verbose_name='关机次数')),
            ],
            options={
                'verbose_name': '开关机次数统计表',
                'verbose_name_plural': '开关机次数统计表',
                'db_table': 'systemLog_switchCount',
            },
        ),
        migrations.CreateModel(
            name='SystemLogSwitchInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('action', models.CharField(blank=True, max_length=45, null=True, verbose_name='动作')),
            ],
            options={
                'verbose_name': '开关机与登录情况表',
                'verbose_name_plural': '开关机与登录情况表',
                'db_table': 'systemLog_switchInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogSystemInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('action', models.CharField(blank=True, max_length=500, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '系统相关信息表',
                'verbose_name_plural': '系统相关信息表',
                'db_table': 'systemLog_systemInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogWarningLevelInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('date', models.CharField(blank=True, max_length=45, null=True, verbose_name='日期')),
                ('time', models.CharField(blank=True, max_length=45, null=True, verbose_name='时间')),
                ('hostName', models.CharField(blank=True, max_length=255, null=True, verbose_name='主机名')),
                ('action', models.CharField(blank=True, max_length=500, null=True, verbose_name='动作')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='具体信息描述')),
            ],
            options={
                'verbose_name': '警告级别表',
                'verbose_name_plural': '警告级别表',
                'db_table': 'systemLog_warningLevelInfo',
            },
        ),
        migrations.CreateModel(
            name='SystemLogXorgInfo',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, verbose_name='id')),
                ('macAddr', models.CharField(blank=True, max_length=45, null=True, verbose_name='单机设备mac地址')),
                ('insertTime', models.BigIntegerField(blank=True, null=True, verbose_name='日志生成时间')),
                ('loadTime', models.CharField(blank=True, max_length=45, null=True, verbose_name='加载时间')),
                ('desc', models.CharField(blank=True, max_length=500, null=True, verbose_name='描述')),
            ],
            options={
                'verbose_name': 'xorg信息表',
                'verbose_name_plural': 'xorg信息表',
                'db_table': 'systemLog_xorgInfo',
            },
        ),
    ]
